#pragma once



#include <string>
using std::string;

extern int g_stage;
extern DWORD g_tick;
extern int g_enq;

string getConfig(string key);
int getConfig_INT(string key);

void saveConfig(string key, string val);
void saveConfig(string key, int val);
void saveConfig(string key, double val);

//WORD calccrc(BYTE crcbuf, WORD crc, WORD polynom);

//WORD chkcrc_modbus(BYTE *buf, WORD len, WORD polynom);

std::string getCurrentDate();
std::string getCurrentTime();
std::string getCurrentTime_Short();

WORD calccrc(BYTE crcbuf, WORD crc);
WORD chkcrc(BYTE *buf, WORD len);


template <class T>
void numberToBuffer(T  number, int len, unsigned char * buf, bool isReversed = false)
{
	if (isReversed)
	{
		for (int i = 0; i<len; i++)
			*((unsigned char *)(buf + len - i - 1)) = (unsigned char)(number / (T)pow(256.0, len - i - 1)) % 256L;
	}
	else
	{
		for (int i = 0; i<len; i++)
			*((unsigned char *)(buf + i)) = (unsigned char)(number / (T)pow(256.0, len - i - 1)) % 256L;
	}
}

template <class T>
void bufferToNumber(const unsigned char * buf, int len, T & number, bool isReversed = false)
{
	number = 0;
	if (isReversed)
	{
		for (int i = 0; i<len; i++)
			number += *((unsigned char *)(buf + i)) * (T)pow(256.0, i);
	}
	else
	{
		for (int i = 0; i<len; i++)
			number += *((unsigned char *)(buf + i)) * (T)pow(256.0, len - i - 1);
	}
}

unsigned char XORChecksum(unsigned char bytes[], int len);
